/*
 * JDialogInconsistentFailCodes.java
 * 
 * Copyright 2008 James Fisher
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA
 */
package com.sittinglittleduck.DirBuster.gui;

import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.regex.PatternSyntaxException;

import javax.swing.JOptionPane;

import com.sittinglittleduck.DirBuster.diff.Diff;
import com.sittinglittleduck.DirBuster.diff.DiffPrint;

/**
 *
 * @author  james
 */
public class JDialogInconsistentFailCodes extends javax.swing.JDialog
{

    private String response1;
    private String response2;
    private String response3;
    private String url;

    /** Creates new form JDialogInconsistentFailCodes */
    public JDialogInconsistentFailCodes(java.awt.Frame parent, boolean modal, String response1, String responce2, String responce3, String url)
    {
        super(parent, modal);
        this.response1 = response1;
        this.response2 = responce2;
        this.response3 = responce3;
        this.url = url;
        initComponents();
        
        jLabelFailURL.setText(url);

        jTextAreaResponse1.setText(response1);
        jTextAreaResponse1.setCaretPosition(0);
        jTextAreaResponse2.setText(response2);
        jTextAreaResponse2.setCaretPosition(0);
        jTextAreaRsponce3.setText(responce3);
        jTextAreaRsponce3.setCaretPosition(0);

        String temp1a[] = response1.split("\r?\n");
        String temp2a[] = responce2.split("\r?\n");
        String temp3a[] = responce3.split("\r?\n");

        Diff d1 = new Diff(temp1a, temp2a);
        Diff d2 = new Diff(temp1a, temp3a);
        Diff d3 = new Diff(temp2a, temp3a);

        Diff.change script1 = d1.diff_2(false);
        Diff.change script2 = d2.diff_2(false);
        Diff.change script3 = d3.diff_2(false);

        DiffPrint.Base p1;
        DiffPrint.Base p2;
        DiffPrint.Base p3;
        //p = new DiffPrint.ContextPrint(temp1a, temp2a);
        //p = new DiffPrint.NormalPrint(temp1a, temp2a);
        //p = new DiffPrint.EdPrint(temp1a, temp2a);
        p1 = new DiffPrint.UnifiedPrint(temp1a, temp2a);
        p2 = new DiffPrint.UnifiedPrint(temp1a, temp3a);
        p3 = new DiffPrint.UnifiedPrint(temp2a, temp3a);


        jTextAreaDiff1_2.setText(p1.print_script(script1));
        jTextAreaDiff1_2.setCaretPosition(0);

        jTextAreaDiff1_3.setText(p2.print_script(script2));
        jTextAreaDiff1_3.setCaretPosition(0);

        jTextAreaDiff2_3.setText(p3.print_script(script3));
        jTextAreaDiff2_3.setCaretPosition(0);

        this.setTitle("Warning unable to determine consistent fail response");
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextAreaResponse1 = new javax.swing.JTextArea();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextAreaResponse2 = new javax.swing.JTextArea();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTextAreaRsponce3 = new javax.swing.JTextArea();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTextAreaDiff1_2 = new javax.swing.JTextArea();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTextAreaDiff1_3 = new javax.swing.JTextArea();
        jScrollPane6 = new javax.swing.JScrollPane();
        jTextAreaDiff2_3 = new javax.swing.JTextArea();
        jLabel2 = new javax.swing.JLabel();
        jLabelFailURL = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jTextFieldRegex = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jButtonCancel = new javax.swing.JButton();
        jButtonOk = new javax.swing.JButton();
        jButtonTest = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jLabel1.setText("The web server you are testing is returning inconsistent pages for dir/files that do not exist");

        jTextAreaResponse1.setColumns(20);
        jTextAreaResponse1.setRows(5);
        jScrollPane1.setViewportView(jTextAreaResponse1);

        jTabbedPane1.addTab("Response 1", jScrollPane1);

        jTextAreaResponse2.setColumns(20);
        jTextAreaResponse2.setRows(5);
        jScrollPane2.setViewportView(jTextAreaResponse2);

        jTabbedPane1.addTab("Response 2", jScrollPane2);

        jTextAreaRsponce3.setColumns(20);
        jTextAreaRsponce3.setRows(5);
        jScrollPane3.setViewportView(jTextAreaRsponce3);

        jTabbedPane1.addTab("Response 3", jScrollPane3);

        jTextAreaDiff1_2.setColumns(20);
        jTextAreaDiff1_2.setRows(5);
        jScrollPane4.setViewportView(jTextAreaDiff1_2);

        jTabbedPane1.addTab("Diff 1 : 2", jScrollPane4);

        jTextAreaDiff1_3.setColumns(20);
        jTextAreaDiff1_3.setRows(5);
        jScrollPane5.setViewportView(jTextAreaDiff1_3);

        jTabbedPane1.addTab("Diff 1 : 3", jScrollPane5);

        jTextAreaDiff2_3.setColumns(20);
        jTextAreaDiff2_3.setRows(5);
        jScrollPane6.setViewportView(jTextAreaDiff2_3);

        jTabbedPane1.addTab("Diff 2 : 3", jScrollPane6);

        jLabel2.setText("Request: ");

        jLabelFailURL.setText("url");

        jLabel4.setText("Please examine the responce returned, and enter a regular expression that will match on all 3 of the attemps.");

        jLabel5.setText("The reglar expression will then be used to determine if the dir/files does or does not exist.");

        jLabel6.setText("Regex to match a fail:");

        jLabel7.setText("With out this DirBuster will return a large number of false positives.");

        jButtonCancel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/sittinglittleduck/DirBuster/gui/icons/fileclose.png"))); // NOI18N
        jButtonCancel.setText("Cancel");
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelActionPerformed(evt);
            }
        });

        jButtonOk.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/sittinglittleduck/DirBuster/gui/icons/accept.png"))); // NOI18N
        jButtonOk.setText("OK");
        jButtonOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOkActionPerformed(evt);
            }
        });

        jButtonTest.setText("Test");
        jButtonTest.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonTestActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 832, Short.MAX_VALUE)
                    .addComponent(jLabel1)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelFailURL))
                    .addComponent(jLabel4)
                    .addComponent(jLabel5)
                    .addComponent(jLabel7)
                    .addGroup(layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldRegex, javax.swing.GroupLayout.PREFERRED_SIZE, 455, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButtonTest))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButtonCancel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 664, Short.MAX_VALUE)
                        .addComponent(jButtonOk)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addGap(8, 8, 8)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jLabelFailURL))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 294, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel7)
                .addGap(11, 11, 11)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jTextFieldRegex, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButtonTest))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonCancel)
                    .addComponent(jButtonOk, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-866)/2, (screenSize.height-541)/2, 866, 541);
    }// </editor-fold>//GEN-END:initComponents

private void jButtonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelActionPerformed

    int n = JOptionPane.showConfirmDialog(
            this,
            "If you cancel this options, DirBuster will will generate a lot of false Positives\n" +
            "Are you sure you wish to cancel?",
            "Are you sure?",
            JOptionPane.YES_NO_OPTION);
    //if the anwser is yes
    if (n == 0)
    {
        this.dispose();
    }

}//GEN-LAST:event_jButtonCancelActionPerformed

private void jButtonOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOkActionPerformed

    if(jTextFieldRegex.getText().equals(""))
    {
        JOptionPane.showMessageDialog(
                        this,
                        "You must enter a regex to test if it works!",
                        "Error",
                        JOptionPane.ERROR_MESSAGE);
        return;
    }
    
    /*
     * check it is a valid regex
     */
    Pattern regexFindFile = null;
    try
    {
        regexFindFile = Pattern.compile(jTextFieldRegex.getText());
    }
    catch(PatternSyntaxException e)
    {
        JOptionPane.showMessageDialog(
                        this,
                        "You must enter a valid regex to test if it works!",
                        "Error",
                        JOptionPane.ERROR_MESSAGE);
        return;
    }

    Matcher m1 = regexFindFile.matcher(response1);
    Matcher m2 = regexFindFile.matcher(response2);
    Matcher m3 = regexFindFile.matcher(response3);
    
    boolean test1 = m1.find();
    boolean test2 = m2.find();
    boolean test3 = m3.find();
    
    if(test1 && test2 && test3)
    {
        this.dispose();
    }
    else
    {
        String result1 = "Fail";
        String result2 = "Fail";
        String result3 = "Fail";
        
        if(test1)
        {
            result1 = "Pass";
        }
        
        if(test2)
        {
            result2 = "Pass";    
        }
        
        if(test3)
        {
            result3 = "Pass";
        }
        
        JOptionPane.showMessageDialog(
                        this,
                        "Test results\n" +
                        "response 1: " + result1 + "\n" +
                        "responce 2: " + result2 + "\n" +
                        "responce 3: " + result3 + "\n" +
                        "Your regex does not work all the responses returned, please try again.",
                        "Error",
                        JOptionPane.ERROR_MESSAGE);
        return;
    }
    
    
}//GEN-LAST:event_jButtonOkActionPerformed

private void jButtonTestActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonTestActionPerformed

    /*
     * Check a regex has been entered
     */
    if(jTextFieldRegex.getText().equals(""))
    {
        JOptionPane.showMessageDialog(
                        this,
                        "You must enter a regex to test if it works!",
                        "Error",
                        JOptionPane.ERROR_MESSAGE);
        return;
    }
    
    /*
     * check it is a valid regex
     */
    Pattern regexFindFile = null;
    try
    {
        regexFindFile = Pattern.compile(jTextFieldRegex.getText());
    }
    catch(PatternSyntaxException e)
    {
        JOptionPane.showMessageDialog(
                        this,
                        "You must enter a valid regex to test if it works!",
                        "Error",
                        JOptionPane.ERROR_MESSAGE);
        return;
    }

    Matcher m1 = regexFindFile.matcher(response1);
    Matcher m2 = regexFindFile.matcher(response2);
    Matcher m3 = regexFindFile.matcher(response3);
    
    boolean test1 = m1.find();
    boolean test2 = m2.find();
    boolean test3 = m3.find();
    
    if(test1 && test2 && test3)
    {
        JOptionPane.showMessageDialog(
                        this,
                        "Test results\n" +
                        "response 1: Pass\n" +
                        "responce 2: Pass\n" +
                        "responce 3: Pass\n" +
                        "This regex should work",
                        "Regex Matches",
                        JOptionPane.INFORMATION_MESSAGE);
        return;
    }
    else
    {
        String result1 = "Fail";
        String result2 = "Fail";
        String result3 = "Fail";
        
        if(test1)
        {
            result1 = "Pass";
        }
        
        if(test2)
        {
            result2 = "Pass";    
        }
        
        if(test3)
        {
            result3 = "Pass";
        }
        
        JOptionPane.showMessageDialog(
                        this,
                        "Test results\n" +
                        "response 1: " + result1 + "\n" +
                        "responce 2: " + result2 + "\n" +
                        "responce 3: " + result3 + "\n" +
                        "Your regex does not work all the responses returned, please try again.",
                        "Error",
                        JOptionPane.ERROR_MESSAGE);
    }
    
    
}//GEN-LAST:event_jButtonTestActionPerformed

/*
 * this is called to show the diaglog and get the regex that was entered
 */

public String showAndGetRegex()
{
    this.setVisible(true);
    return jTextFieldRegex.getText();
}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonCancel;
    private javax.swing.JButton jButtonOk;
    private javax.swing.JButton jButtonTest;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabelFailURL;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextArea jTextAreaDiff1_2;
    private javax.swing.JTextArea jTextAreaDiff1_3;
    private javax.swing.JTextArea jTextAreaDiff2_3;
    private javax.swing.JTextArea jTextAreaResponse1;
    private javax.swing.JTextArea jTextAreaResponse2;
    private javax.swing.JTextArea jTextAreaRsponce3;
    private javax.swing.JTextField jTextFieldRegex;
    // End of variables declaration//GEN-END:variables
}
